package com.dsk.flink.dsc.common.function;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.flink.api.common.functions.MapFunction;
import org.apache.flink.api.java.tuple.Tuple3;

import java.util.HashSet;
import java.util.Set;

public class CanalMapToTsGroupFunction implements MapFunction<JSONObject, Tuple3<JSONObject, String, Long>> {
    @Override
    public Tuple3<JSONObject, String, Long> map(JSONObject value) throws Exception {

        JSONArray dataList = value.getJSONArray("data");
        JSONObject mysqlType = value.getJSONObject("mysqlType");
        String table = value.getString("table");
        JSONArray pkNames = value.getJSONArray("pkNames");
        Set<String> pkNameSet = new HashSet<>();
        long ts = value.getLong("ts");
        if (CollUtil.isNotEmpty(pkNames)) {
            pkNames.forEach(name -> pkNameSet.add(String.valueOf(name)));
        }
        JSONObject dataObj = dataList.getJSONObject(0);
        String groupKey = table;
        for (String pk : pkNameSet) {
            String pkValue = AsyncDamengDataTransferFunction.getValueString(dataObj, pk,
                    mysqlType.getString(pk));
            groupKey = table.concat("-").concat(pkValue);
        }

        return Tuple3.of(value, groupKey, ts);
    }
}
