package com.dsk.flink.dsc.common.function;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import org.apache.flink.api.java.tuple.Tuple3;
import org.apache.flink.streaming.api.functions.windowing.ProcessWindowFunction;
import org.apache.flink.streaming.api.windowing.windows.TimeWindow;
import org.apache.flink.util.Collector;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class GroupTsProcessWindowFunction extends ProcessWindowFunction<Tuple3<JSONObject, String, Long>, JSONObject, Long, TimeWindow> {
    @Override
    public void process(Long aLong, ProcessWindowFunction<Tuple3<JSONObject, String, Long>, JSONObject, Long,
            TimeWindow>.Context context, Iterable<Tuple3<JSONObject, String, Long>> elements, Collector<JSONObject> out) throws Exception {

        List<Tuple3<JSONObject, String, Long>> list = CollUtil.list(false, elements);
        Map<Long, List<Tuple3<JSONObject, String, Long>>> tsGroupMap = list.stream().collect(Collectors.groupingBy(x -> x.f2));
        Long max = CollUtil.max(tsGroupMap.keySet());
        List<Tuple3<JSONObject, String, Long>> resList = tsGroupMap.get(max);
        if(resList.size() == 2){
            JSONObject insertJson = new JSONObject();
            JSONObject deleteJson = new JSONObject();
            for (Tuple3<JSONObject, String, Long> rs : resList) {
                if("INSERT".equals(rs.f0.getString("type"))){
                    insertJson = rs.f0;
                }
                if("DELETE".equals(rs.f0.getString("type"))){
                    deleteJson = rs.f0;
                }
            }
            if(StrUtil.isNotBlank(insertJson.getString("type")) && StrUtil.isNotBlank(deleteJson.getString("type"))){
                insertJson.put("type","UPDATE");
                insertJson.put("old", deleteJson.getJSONArray("data"));
                out.collect(insertJson);
                return;
            }
        }
        out.collect(resList.get(0).f0);
    }
}
